/*
 * Copyright (c) 2018-2999 广州亚米信息科技有限公司 All rights reserved.
 *
 * https://www.gz-yami.com/
 *
 */

package com.yami.shop.groupbuy.comment.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.yami.shop.bean.dto.OrderRefundDto;
import com.yami.shop.common.util.PageParam;
import com.yami.shop.groupbuy.comment.api.dto.ApiGroupProdDto;
import com.yami.shop.groupbuy.comment.dto.GroupProdAndSkuListDto;
import com.yami.shop.groupbuy.comment.dto.GroupProdDto;
import com.yami.shop.groupbuy.comment.model.GroupProd;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 拼团活动商品表
 *
 * @author LGH
 * @date 2019-08-27 17:55:57
 */
public interface GroupProdService extends IService<GroupProd> {

    IPage<GroupProdDto> getGroupProdPage(PageParam<GroupProd> page, GroupProd groupProd);

    /**
     * 保存活动商品
     */
    List<Long> saveByProdIds(Long shopId, Long groupActivityId, List<Long> prodIds);

    /**
     * 获取活动商品及规格属性
     */
    GroupProdAndSkuListDto getGroupProdAndSkuListById(Long groupProdId);

    /**
     * 通过活动商品id删除活动商品
     */
    void updateGroupProdToDelByGroupProd(GroupProd groupProd);

    /**
     * API-活动商品列表
     *
     * @param page 分页对象
     * @return 分页数据
     */
    IPage<ApiGroupProdDto> getApiGroupProdPage(PageParam<OrderRefundDto> page);

    /**
     * api - 通过活动规格id获取活动商品信息
     */
    GroupProd getGroupProdByGroupSkuId(Long groupSkuId);

    /**
     * 获取活动商品信息
     *
     * @param groupProdId 活动商品ID
     * @return ApiGroupProdDto对象
     */
    ApiGroupProdDto getApiGroupProdDto(Long groupProdId);

    /**
     * 通过活动商品id获取活动商品
     */
    GroupProd getGroupProdById(Long groupProdId);

    /**
     * 移除活动商品缓存
     */
    void removeGroupProdCache(Long groupProdId);

    /**
     * 更新活动商品为删除状态
     */
    void delGroupProd(GroupProd groupProd);

    /**
     * 失效活动商品
     */
    void invalidGroupProd(GroupProd groupProd);

    /**
     * 失效指定活动的活动商品
     * @param groupActivityIds
     */
    void invalidGroupProdByActivityId(List<Long> groupActivityIds);
}
